package com.totopia.server.user.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.CreationTimestamp;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Entity
@Table(name = "TBL_USER_GROUP")
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class UserGroup implements Serializable {
    @Id
    @GeneratedValue(generator = "user_group_generator")
    @SequenceGenerator(name = "user_group_generator", sequenceName = "user_group_sequence", initialValue = 1, allocationSize = 1)
    private Long id;

    @Basic
    @Column(name = "title", nullable = false, length = 100)
    @JsonIgnore
    private String title;

    @Basic
    @Column(columnDefinition = "text", name = "description", nullable = true)
    private String description;

    @Basic
    @Column(name = "is_default", nullable = false, columnDefinition = "bool default false")
    private Boolean isDefault;

    @Basic
    @CreationTimestamp
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "register_date", nullable = false)
    private Date registerDate;
}
